#version 330 core

uniform mat4 PVM;
uniform mat4 Bones[62];

in  vec4 in_position;
in  vec4 in_weight;
in  vec4 in_boneindices;
 

void main(void) {
 
 //   gl_Position = PVM * in_position;
	vec4 newVertex;
        vec4 newNormal;
        int index;
	//-----------------------
	index=int(in_boneindices.x);
        newVertex = (Bones[index] * in_position) * in_weight.x;

	if(in_boneindices.y != -1) {
	  index=int(in_boneindices.y);
          newVertex = (Bones[index] * in_position) * in_weight.y + newVertex;
	}

	if(in_boneindices.z != -1) {
	  index=int(in_boneindices.z);
          newVertex = (Bones[index] * in_position) * in_weight.z + newVertex;
	}

	if(in_boneindices.w != -1) {
	  index=int(in_boneindices.w);
          newVertex = (Bones[index] * in_position) * in_weight.w + newVertex;
	}
	//-----------------------

	gl_Position = PVM * vec4(newVertex.xyz, 1.0);
}